=== debian/changelog ===
pupnp (1:1.14.18-1.1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:54 +0000

pupnp (1:1.14.18-1.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Mar 2024 12:18:17 +0100

pupnp (1:1.14.18-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063296

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:24:41 +0000

pupnp (1:1.14.18-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Sep 2023 14:38:00 +0200

pupnp (1:1.14.18-1) unstable; urgency=medium

  * New upstream version 1.14.18

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Sep 2023 18:47:27 +0200

pupnp (1:1.14.17-2ubuntu4) mantic; urgency=medium

  * Try to call correct gcc/pkg-config on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Jun 2023 17:36:17 +0200

pupnp (1:1.14.17-2ubuntu2) mantic; urgency=medium

  * Patch also CMakeLists.txt to export LFS_CFLAGS on 32bit architectures.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Jun 2023 11:08:07 +0200

pupnp (1:1.14.17-2ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 14 Jun 2023 10:02:56 +0200

pupnp (1:1.14.17-2) unstable; urgency=medium

  * debian/rules: Fix indep build

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 12 Jun 2023 08:04:46 +0200

pupnp (1:1.14.17-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 1.14.17

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 10 Jun 2023 14:48:54 +0200

pupnp (1:1.14.16-1) experimental; urgency=medium

  [ James Cowgill ]
  * d/control: Drop Multi-Arch: same from libupnp-dev
  * d/tests: Replace ADTTMP with AUTOPKGTEST_TMP

  [ Bryan Quigley ]
  * New upstream release 1.14.0

  [ Sebastian Ramacher ]
  * New upstream version 1.14.16
    - Fix CVE-2020-12695 (Closes: #983206)
    - Fix CVE-2021-29462 (Closes: #987326)
    - Fix CVE-2020-13848 (Closes: #962282)
    - Fix CVE-2021-28302 (Closes: #986833)
  * SONAME bump:
    - libixml10 -> libixml11
    - libupnp13 -> libupnp17
  * debian/: Remove explicit version from source package name and Description
  * debian/control:
    - Adopt is part of the Multimedia team (Closes: #1033858)
    - Update homepage
    - Bump Standards-Version
  * debian/: Bump to debhelper compat 13

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 03 Apr 2023 00:16:37 +0200

pupnp-1.8 (1:1.8.4-2ubuntu2) disco; urgency=medium

  * Fix autopkgtest for 32-bit archs.
  * Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
    required by the headers anyway.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Nov 2018 10:41:27 -0800

pupnp-1.8 (1:1.8.4-2) unstable; urgency=medium

  * Upload to unstable.

 -- James Cowgill <jcowgill@debian.org>  Mon, 05 Nov 2018 19:55:05 +0000

pupnp-1.8 (1:1.8.4-1) experimental; urgency=medium

  * New upstream release.
  * Doxyfile: Revert Debian specific changes to doxygen config. None of
    them have any significant benefits.

  * d/changelog: Remove extra whitespace lines.
  * d/compat: Use debhelper compat 11.
  * d/control:
    - d/control: Move Vcs-* repositories to salsa.d.o.
    - d/control: Bump standards to 4.2.1.
  * d/libupnp-doc.*:
    - Move docs to usr/share/doc/libupnp-dev per policy 3.9.7.
  * d/rules:
    - Revert "Implement build targets manually in debian/rules". Newer
      debhelper versions handle this properly.
    - d/rules: Create docs/doxygen directory.

 -- James Cowgill <jcowgill@debian.org>  Sat, 27 Oct 2018 15:42:13 +0100

pupnp-1.8 (1:1.8.3-3) experimental; urgency=medium

  * Rename libupnp1.8-doc to libupnp-doc.
  * Fix Build-Depends-Package in symbols files.
  * Manually bump SONAME of libupnp to libupnp.so.13. Rename libupnp10 to
    libupnp13. (Closes: #882377)

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Dec 2017 11:39:44 +0000

pupnp-1.8 (1:1.8.3-2) experimental; urgency=medium

  * debian/control:
    - Bump standards version to 4.1.2.
  * debian/patches:
    - Renumber.
    - Add upstream patch to remove inclusion of ThreadPool.h from upnpdebug.h.
      (Closes: #884252)

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Dec 2017 00:03:52 +0000

pupnp-1.8 (1:1.8.3-1) experimental; urgency=medium

  * New upstream release.

  * debian/changelog:
    - Remove trailing whitespace.
  * debian/control:
    - Rename libupnp1.8-dev to libupnp-dev. (Closes: #873656)
    - Move libupnp-1.8-dev conflicts to breaks.
    - Add versions to breaks and replaces.
    - Remove unnecessary Testsuite: autopkgtest header.
    - Set Rules-Requires-Root: no.
    - Bump standards version to 4.1.1.
  * debian/copyright:
    - Update.
  * debian/patches:
    - Refresh.
  * debian/rules:
    - Implement build targets manually in debian/rules.
    - Don't suppress doxygen log output.

 -- James Cowgill <jcowgill@debian.org>  Tue, 21 Nov 2017 21:23:05 +0000

pupnp-1.8 (1:1.8.2-3) unstable; urgency=medium

  * debian/rules:
    - Build with --enable-reuseaddr option.

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Sep 2017 18:56:47 +0100

pupnp-1.8 (1:1.8.2-2) unstable; urgency=medium

  * debian/control:

