=== debian/control ===
Source: pupnp
Section: net
Priority: optional
Homepage: https://pupnp.github.io/pupnp/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Sebastian Ramacher <sramacher@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 cmake,
 ninja-build,
Build-Depends-Indep:
 doxygen,
 doxygen-latex,
 graphviz,
 texlive-latex-base,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git

Package: libupnp-dev
Architecture: any
Section: libdevel
Depends:
 libixml11t64 (= ${binary:Version}),
 libupnp17t64 (= ${binary:Version}),
 ${misc:Depends}
Suggests: libupnp-doc
Description: Portable SDK for UPnP Devices, version 1.14 (development files)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libupnp-dev package contains the header files, documentation and
 debug versions of libraries needed for development of programs using
 uPnP.

Package: libupnp17t64
Provides: ${t64:Provides}
Replaces: libupnp17
Breaks: libupnp17 (<< ${source:Version})
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libupnp17t64 package contains the runtime library for uPnP.

Package: libixml11t64
Provides: ${t64:Provides}
Replaces: libixml11
Breaks: libixml11 (<< ${source:Version})
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (ixml shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libixml10 package contains the runtime libraries for the Linux DOM2
 XML Parser (IXML).

Package: libupnp-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the Portable SDK for UPnP Devices
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the HTML documentation for the libupnp library
 in /usr/share/doc/libupnp-dev/
