## pupnp 1.14.19

=== debian/changelog ===
pupnp (1:1.14.19-2ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.
  * d/p/444.patch
    - cherry-pick upstream fixes for some more cmake warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 May 2024 11:33:02 +0200

pupnp (1:1.14.19-2) unstable; urgency=medium

  * debian/patches: Apply upstream fixes for package version (Closes:
    #1070690)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 09 May 2024 19:02:10 +0200

pupnp (1:1.14.19-1ubuntu2) oracular; urgency=medium

  * Switch pkg-config to pkgconf (to heal i386 autopkgtests)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 May 2024 10:22:01 +0200

pupnp (1:1.14.19-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.
  * d/p/443.patch
  * d/p/444.patch
    - cherry-pick upstream fixes for empty version on pkgconf file
      (Closes: #1070690)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 May 2024 12:44:48 +0200

pupnp (1:1.14.19-1) unstable; urgency=medium

  * New upstream version 1.14.19
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 05 May 2024 19:14:43 +0200
