=== upnp/generator/Makefile ===
CFLAGS=-Wall

generator: generator.o

clean:
	rm -f generator.o generator 2> /dev/null
