=== debian/changelog ===
pupnp (1:1.14.20-1) unstable; urgency=medium

  * New upstream version 1.14.20
  * debian/patches: Remove patches from upstream
  * debian/*.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 15 Dec 2024 19:06:48 +0100
