## pupnp 1.14.20-1+11.0trisquel1

=== debian/changelog ===
pupnp (1:1.14.20-1+11.0trisquel1) aramo-backports; urgency=medium

  * Imported into trisquel backports as part of jami dependency.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 18 Dec 2024 06:43:34 +0000
