=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: net
 Priority: optional
 Homepage: https://pupnp.github.io/pupnp/
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Sebastian Ramacher <sramacher@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends: dpkg-dev (>= 1.21.1ubuntu2.3),
  debhelper-compat (= 13),
  cmake,
  ninja-build,
