## pupnp 1.14.24

=== debian/changelog ===
pupnp (1:1.14.24-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 06 Aug 2025 12:36:18 +0200

pupnp (1:1.14.24-1) experimental; urgency=medium

  * New upstream version 1.14.24

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 19 Jun 2025 18:54:29 +0200

pupnp (1:1.14.23-1) experimental; urgency=medium

  * New upstream version 1.14.23
  * debian/control:
    - Bump Standards-Version
    - Fix descriptions

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 09 Jun 2025 21:52:36 +0200
