=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: net
 Priority: optional
 Homepage: https://pupnp.github.io/pupnp/
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Sebastian Ramacher <sramacher@debian.org>
-Build-Depends: dpkg-dev (>= 1.21.1ubuntu2.3),
+Build-Depends:
+ dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  ninja-build,
@@ -15,7 +16,7 @@
  graphviz,
  texlive-latex-base,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
 Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git
 
@@ -34,7 +35,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libupnp-dev package contains the header files, documentation and
+ This package contains the header files, documentation and
  debug versions of libraries needed for development of programs using
  uPnP.
 
@@ -54,7 +55,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libupnp17t64 package contains the runtime library for uPnP.
+ This package contains the runtime library for uPnP.
 
 Package: libixml11t64
 Provides: ${t64:Provides}
@@ -72,7 +73,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libixml10 package contains the runtime libraries for the Linux DOM2
+ This package contains the runtime libraries for the Linux DOM2
  XML Parser (IXML).
 
 Package: libupnp-doc
