=== debian/changelog ===
pupnp (1:1.14.25-1) unstable; urgency=medium

  * New upstream version 1.14.25

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 13:00:28 +0200

pupnp (1:1.14.24-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Edit tests/control, migrate from pkg-config to pkgconf

  [ Sebastian Ramacher ]
  * debian/control: Remove dependencies to build PDF
  * debian/: Stop building PDF documentation (Closes: #1114272, #1113429)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Sep 2025 21:42:38 +0200
