=== debian/control ===
--- 
+++ 
@@ -12,9 +12,7 @@
  ninja-build,
 Build-Depends-Indep:
  doxygen,
- doxygen-latex,
  graphviz,
- texlive-latex-base,
 Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
