=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,6 @@
 
 override_dh_auto_build-indep:
 	cd docs && doxygen
-	$(MAKE) -C docs/doxygen/latex
 	find docs/doxygen/html -name "*.md5" -o -name "*.map" -delete
 
 override_dh_auto_install-indep:
