=== debian/tests/control ===
Tests: build
Depends: build-essential, libupnp-dev, pkgconf
